﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsAppBsc2024_25_7
{
    public partial class Form1 : Form
    {
        Pen pen;
        Graphics graphics;
        Bitmap bmp;
        Point startPoint, endPoint;
        int drawShape;
        PointF[] points;
        int count;
        int sides=5;//sides of polygon
        Random r = new Random();
        Color[] colors;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Student student = new Student();
            student.name = "John";
            student.grade = 7;
            IFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream("myobj.txt", FileMode.Create, FileAccess.Write);
            formatter.Serialize(stream, student);
            stream.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            IFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream("myobj.txt",FileMode.Open, FileAccess.Read);
            Student student = (Student)formatter.Deserialize(stream);
            MessageBox.Show(student.ToString());
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            pen = new Pen(Color.Black, 3);
            bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            graphics = Graphics.FromImage(bmp);
            graphics.Clear(Color.White);
            pictureBox1.Image = bmp;
            colors = new Color[6];
            colors[0] = Color.Black;
            colors[1] = Color.Red;
            colors[2] = Color.Green;
            colors[3] = Color.Blue;
            colors[4] = Color.Yellow;
            colors[5] = Color.Orange;
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            startPoint = e.Location;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            drawShape = 1; //for line
        }

        private void button4_Click(object sender, EventArgs e)
        {
            pictureBox1.Image.Save("mypic.png",ImageFormat.Png);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            drawShape = 2;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            drawShape = 3;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            drawShape = 4;
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            endPoint = e.Location;
            if (drawShape == 1)
            {
                graphics.DrawLine(pen, startPoint, endPoint);
            }else if(drawShape == 2)
            {
                graphics.DrawRectangle(pen,startPoint.X,startPoint.Y,Math.Abs(endPoint.X-startPoint.X),
                    Math.Abs(endPoint.Y-startPoint.Y));
            }else if(drawShape == 3)
            {
                Point[] points = new Point[3];
                points[0] = new Point(100,100);
                points[1] = new Point(100, 200);
                points[2] = new Point(200, 200);
                graphics.DrawPolygon(pen, points);
            }else if(drawShape == 4)
            {
                createPolygon(startPoint, endPoint, sides,true);
            }else if (drawShape == 5)
            {
                createPolygon(startPoint,endPoint, sides,false);
                timer1.Enabled = true;
            }
            pictureBox1.Refresh();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            drawShape = 5;
            //timer1.Enabled = true;
            timer2.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int choice = r.Next(0, 6);
           
            pen.Color = colors[choice];
            if (count < sides - 1)
            {
                graphics.DrawLine(pen, points[count], points[count + 1]);
                count++;
                pictureBox1.Refresh();
            }
            else if (count == sides - 1)
            {
                graphics.DrawLine(pen,points[count], points[0]);
                count = 0;
                timer1.Enabled= false;
                pictureBox1.Refresh();
            }
                
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            pictureBox2.Location = new Point(pictureBox2.Location.X+10, 
                pictureBox2.Location.Y);
        }

        private void createPolygon(Point start, Point end, int sides, bool draw)
        {
            //βρισκουμε το κέντρο
            var x0 = (start.X + end.X) / 2;
            var y0 = (start.Y + end.Y) / 2;

            //αρχικοποίηση πίνακα points
            points = new PointF[sides];
            float angle = 360 / sides;
            float r = (float)Math.Sqrt(Math.Pow((start.X - end.X), 2)+Math.Pow((start.Y - end.Y), 2))/2;

            for (int i = 0; i < sides; i++) 
            {
                points[i] = new PointF(
                    x0 + r * (float)Math.Cos(i * angle * Math.PI / 180f),
                    y0 + r * (float)Math.Sin(i * angle * Math.PI / 180f));
            }
            if (draw)
            {
                graphics.DrawPolygon(pen, points);
            }
        }

    }
}
